<script lang="ts" setup>
// This component is also used on the /jobs landing page

import type { BaseLink } from '@/types/base';
import type { CustomerLogosProps } from '@/components/common/CustomerLogos.vue';

interface Stat {
  title: string;
  number: string;
  config: {
    col: number;
    href?: string;
    dataGaName?: string;
    dataGaLocation?: string;
  };
}

interface ByTheNumbersProps {
  title: string;
  asOfDate?: string;
  rows: Array<{
    item: Array<Stat>;
  }>;
  ctaBox?: {
    title: string;
    cta: BaseLink;
  };
  customerLogos?: CustomerLogosProps;
}

defineProps<ByTheNumbersProps>();
</script>

<template>
  <SlpSection class="numbers-container" :style="!ctaBox && !customerLogos ? 'padding-bottom: 96px' : ''">
    <div class="numbers">
      <div class="numbers__gradient-header" />
      <div class="heading__container">
        <SlpTypography v-if="title" tag="h2" variant="heading2-bold" class="heading__content-main">
          {{ title }}
        </SlpTypography>
        <SlpTypography v-if="asOfDate">
          {{ asOfDate }}
        </SlpTypography>
      </div>
      <SlpRow v-for="(row, index) in rows" :key="index">
        <SlpColumn :cols="4"></SlpColumn>
        <SlpColumn
          v-for="item in row.item"
          :key="item.title"
          :cols="item.config.col.toString()"
          class="numbers__table-item"
        >
          <div class="mission__description" v-html="$md.render(item.title)"></div>
          <a
            v-if="item.config.href"
            :href="item.config.href"
            class="numbers__number-link"
            :data-ga-name="item.config.dataGaName"
            :data-ga-location="item.config.dataGaLocation"
          >
            <SlpTypography tag="h2" variant="heading2-bold" class="numbers__number slp-color-text-50">
              {{ item.number }}
            </SlpTypography>
          </a>
          <SlpTypography v-else tag="h2" variant="heading2-bold" class="numbers__number">
            {{ item.number }}
          </SlpTypography>
        </SlpColumn>
      </SlpRow>
      <SlpRow v-if="ctaBox">
        <SlpColumn :cols="4"></SlpColumn>
        <SlpColumn :cols="8" class="numbers__cta">
          <div class="numbers__cta-title" v-html="$md.render(ctaBox.title)"></div>
          <SlpButton
            variant="primary"
            :data-ga-name="ctaBox.cta.config.dataGaName"
            :data-ga-location="ctaBox.cta.config.dataGaLocation"
            :href="ctaBox.cta.config.href"
            >{{ ctaBox.cta.text }}
          </SlpButton>
        </SlpColumn>
      </SlpRow>
      <CommonCustomerLogos v-if="customerLogos" v-bind="customerLogos" />
    </div>
  </SlpSection>
</template>

<style lang="scss" scoped>
.numbers-container {
  background-color: $color-surface-700;
  padding-top: $spacing-96;
  color: $color-text-50;

  &:deep(.customer-logos) {
    margin-top: 32px;
    margin-bottom: 112px;

    @media (max-width: $breakpoint-md) {
      margin-top: 48px;
      margin-bottom: 64px;
    }

    .logo {
      flex: 0 1 110px;
      margin: 8px;
      width: 110px;
      min-width: 110px;

      @media (max-width: $breakpoint-md) {
        width: 100px;
      }
    }
    img {
      // Overrides CommonCustomerLogos
      filter: brightness(0) invert(1);
      max-width: 100% !important;
      width: 100% !important;
      height: 100% !important;
      max-height: 60px !important;
    }
  }
}
.heading {
  &__container {
    display: flex;
    justify-content: space-between;
    margin-bottom: 64px;

    .slp-text-body1 {
      display: flex;
      align-items: flex-end;
      color: $color-surface-950;
      font-size: 16px;
    }
  }
}
.mission {
  &__description {
    color: $color-surface-950;
  }
}
.numbers {
  &__gradient-header {
    background: linear-gradient(90deg, #ffc8c6 0%, #b3bded 100%);
    height: 4px;
    width: 95px;
    border-radius: 10px;
    margin-bottom: $spacing-16;
  }

  &__table-item {
    display: flex;
    justify-content: space-between;
    padding: $spacing-32 0;
    align-items: center;
  }

  &__number {
    text-align: right;
  }

  &__number-link:hover {
    text-decoration: underline;
    color: $color-text-50;
  }

  &__table-item.slp-col-md-8 {
    border-top: 2px solid $color-surface-400;
  }

  &__table-item.slp-col-md-4:last-child {
    padding-left: $spacing-16;
    position: relative;

    &:before {
      content: '';
      width: calc(100% - 16px);
      height: 2px;
      background-color: $color-surface-400;
      position: absolute;
      right: 0;
      top: 0;
    }
  }

  &__table-item.slp-col-md-4:nth-of-type(2) {
    padding-right: $spacing-16;
    position: relative;

    &:before {
      content: '';
      width: calc(100% - 16px);
      height: 2px;
      background-color: $color-surface-400;
      position: absolute;
      left: 0;
      top: 0;
    }
  }

  &__cta {
    display: flex;
    justify-content: space-between;
    background: linear-gradient(90.32deg, #e3d6ff 0%, #ffd4d8 100%);
    border-radius: 4px;
    padding: $spacing-24;
    color: $color-text-300;

    @media (min-width: $breakpoint-md) {
      margin-bottom: 64px;
    }
  }

  &__cta-title {
    font-size: 20px;
    line-height: 24px;
    font-weight: 600;
  }

  @media (max-width: $breakpoint-md) {
    .heading {
      &__container {
        flex-direction: column;
        margin-bottom: 16px;
      }

      &__content-main {
        margin-bottom: 64px;
      }
    }
    &__table-item.slp-col-md-4:nth-of-type(2),
    &__table-item.slp-col-md-4:last-child,
    &__table-item.slp-col-md-8 {
      width: 100%;
      padding-left: 0;
      padding-right: 0;
      border-top: 2px solid $color-surface-400;

      &:before {
        display: none;
      }
    }

    &__cta {
      flex-wrap: wrap;

      .slp-btn {
        width: 100%;
        display: block;
        margin-top: $spacing-16;
      }
    }
  }
}
</style>
